/*
 * digital.c
 *
 * Created: 24.01.2014 09:44:11
 *  Author: Sascha
 */ 

#include "digital.h"
#include "led.h"
#include "main.h"

/************************************************************************/
/* Digitaluhr-Methode                                                   */
/************************************************************************/
void showDigitalTime(void) {
	
	turnOffLeds();
	// Linker Rand der DigitalUhr
	if(segmentsPosition == 164) {
		cntDigital = 0;
		checkDigitalFirstNumberHours();
	} else
	if(segmentsPosition == 165) {
		cntDigital = 1;
		checkDigitalFirstNumberHours();
	} else
	if(segmentsPosition == 167) {
		cntDigital = 2;
		checkDigitalFirstNumberHours();
	} else
	if(segmentsPosition == 168) {
		cntDigital = 3;
		checkDigitalFirstNumberHours();
	} else
	if(segmentsPosition == 169) {
		cntDigital = 4;
		checkDigitalFirstNumberHours();
	} else
	if(segmentsPosition == 172) {
		cntDigital = 0;
		checkDigitalSecondNumberHours();
	} else
	if(segmentsPosition == 173) {
		cntDigital = 1;
		checkDigitalSecondNumberHours();
	} else
	if(segmentsPosition == 174) {
		cntDigital = 2;
		checkDigitalSecondNumberHours();
	} else
	if(segmentsPosition == 175) {
		cntDigital = 3;
		checkDigitalSecondNumberHours();
	} else
	if(segmentsPosition == 176) {
		cntDigital = 4;
		checkDigitalSecondNumberHours();
	} else
	if(segmentsPosition == 179) {
		PORTC =  ~((1<<PC2) | (1<<PC4));
	} else
	if(segmentsPosition == 2) {
		cntDigital = 0;
		checkDigitalFirstNumberMinutes();
	} else
	if(segmentsPosition == 3) {
		cntDigital = 1;
		checkDigitalFirstNumberMinutes();
	} else
	if(segmentsPosition == 4) {
		cntDigital = 2;
		checkDigitalFirstNumberMinutes();
	} else
	if(segmentsPosition == 5) {
		cntDigital = 3;
		checkDigitalFirstNumberMinutes();
	} else
	if(segmentsPosition == 6) {
		cntDigital = 4;
		checkDigitalFirstNumberMinutes();
	} else
	if(segmentsPosition == 9) {
		cntDigital = 0;
		checkDigitalSecondNumberMinutes();
	} else
	if(segmentsPosition == 10) {
		cntDigital = 1;
		checkDigitalSecondNumberMinutes();
	} else
	if(segmentsPosition == 11) {
		cntDigital = 2;
		checkDigitalSecondNumberMinutes();
	} else
	if(segmentsPosition == 12) {
		cntDigital = 3;
		checkDigitalSecondNumberMinutes();
	} else
	if(segmentsPosition == 13) {
		cntDigital = 4;
		checkDigitalSecondNumberMinutes();
	}
}

/************************************************************************/
/* Erste Stunden Ziffer anzeigen                                        */
/************************************************************************/
void checkDigitalFirstNumberHours(void) {
	uint8_t firstNumber = 0;
	// Teilen der Stelle
	if( hours >= 10) {
		firstNumber = hours / 10;
		} else {
		firstNumber = 0;
	}
	
	intToDigital(firstNumber);	
}

/************************************************************************/
/* Zweite Stunden Ziffer anzeigen                                       */
/************************************************************************/
void checkDigitalSecondNumberHours(void) {
	uint8_t firstNumber = 0;
	uint8_t secondNumber = 0;
	// Teilen der Stelle
	if( hours >= 10) {
		firstNumber = hours / 10;
		secondNumber = hours - (firstNumber * 10);
		} else {
		secondNumber = hours;
	}
	
	intToDigital(secondNumber);	
}

/************************************************************************/
/* Erste Minuten Ziffer anzeigen                                        */
/************************************************************************/
void checkDigitalFirstNumberMinutes(void) {
	// Teilen der Stelle
	uint8_t firstNumber = 0;
	// Teilen der Stelle
	if( minutes >= 10) {
		firstNumber = minutes / 10;
		} else {
		firstNumber = 0;
	}
	
	intToDigital(firstNumber);
}

/************************************************************************/
/* Zweite Stunden Ziffer anzeigen                                       */
/************************************************************************/
void checkDigitalSecondNumberMinutes(void) {
	// Teilen der Stelle
	uint8_t firstNumber = 0;
	uint8_t secondNumber = 0;
	if( minutes >= 10) {
		firstNumber = minutes / 10;
		secondNumber = minutes - (firstNumber * 10);
		} else {
		secondNumber = minutes;
	}
	
	intToDigital(secondNumber);
}

/************************************************************************/
/* bersetzung von Zahl in Digital-Anzeige                              */
/************************************************************************/
void intToDigital(uint8_t number) {
	turnOffLeds();
	switch(number) {
		case 0: digitalZero(); break;
		case 1: digitalOne(); break;
		case 2: digitalTwo(); break;
		case 3: digitalThree(); break;
		case 4: digitalFour(); break;
		case 5: digitalFive(); break;
		case 6: digitalSix(); break;
		case 7: digitalSeven(); break;
		case 8: digitalEight(); break;
		case 9: digitalNine(); break;
	}
}

/************************************************************************/
/* Darstellung Digital 0                                                */
/************************************************************************/
void digitalZero(void) {
	// LED16	-###-
	// LED15	#---#
	// LED14	#---#
	// LED13	#---#
	// LED12	#---#
	// LED11	-###-
	switch(cntDigital) {
		case 0: case 4:
		setLedMode(14, true); setLedMode(13, true); setLedMode(12, true); setLedMode(11, true);
		break;
		case 1: case 2: case 3:
		setLedMode(15, true); setLedMode(10, true);
		break;
	}
}

/************************************************************************/
/* Darstellung Digital 1                                                */
/************************************************************************/
void digitalOne(void) {
	// LED16	--##-
	// LED15	-#-#-
	// LED14	#--#-
	// LED13	---#-
	// LED12	---#-
	// LED11	-####
	switch(cntDigital) {
		case 0:
		setLedMode(13, true);
		break;
		case 1:
		setLedMode(14, true); setLedMode(10, true);
		break;
		case 2:
		setLedMode(15, true); setLedMode(10, true);
		break;
		case 3:
		setLedMode(15, true); setLedMode(14, true); setLedMode(13, true); setLedMode(12, true); setLedMode(11, true); setLedMode(10, true);
		break;
		case 4:
		setLedMode(10, true);
		break;
	}
}

/************************************************************************/
/* Darstellung Digital 2                                                */
/************************************************************************/
void digitalTwo(void) {
	// LED16	-###-
	// LED15	#---#
	// LED14	---#-
	// LED13	--#--
	// LED12	-#---
	// LED11	#####
	switch(cntDigital) {
		case 0: case 4:
		setLedMode(14, true); setLedMode(10, true);
		break;
		case 1:
		setLedMode(15, true); setLedMode(11, true); setLedMode(10, true);
		break;
		case 2:
		setLedMode(15, true); setLedMode(12, true); setLedMode(10, true);
		break;
		case 3:
		setLedMode(15, true); setLedMode(13, true); setLedMode(10, true);
		break;
	}
}

/************************************************************************/
/* Darstellung Digital 3                                                */
/************************************************************************/
void digitalThree(void) {
	// LED16	-###-
	// LED15	#---#
	// LED14	----#
	// LED13	-###-
	// LED12	----#
	// LED11	####-
	switch(cntDigital) {
		case 0:
		setLedMode(14, true); setLedMode(10, true);
		break;
		case 1: case 2: case 3:
		setLedMode(15, true); setLedMode(12, true); setLedMode(10, true);
		break;
		case 4:
		setLedMode(14, true); setLedMode(13, true); setLedMode(11, true);
		break;
	}
}

/************************************************************************/
/* Darstellung Digital 4                                                */
/************************************************************************/
void digitalFour(void) {
	// LED16	#----
	// LED15	#----
	// LED14	#--#-
	// LED13	#####
	// LED12	---#-
	// LED11	---#-
	switch(cntDigital) {
		case 0:
		setLedMode(15, true); setLedMode(14, true); setLedMode(13, true); setLedMode(12, true);
		break;
		case 1: case 2: case 4:
		setLedMode(12, true);
		break;
		case 3:
		setLedMode(13, true); setLedMode(12, true); setLedMode(11, true); setLedMode(10, true);
		break;
	}
}

/************************************************************************/
/* Darstellung Digital 5                                                */
/************************************************************************/
void digitalFive(void) {
	// LED16	#####
	// LED15	#----
	// LED14	-###-
	// LED13	----#
	// LED12	#---#
	// LED11	-###-
	switch(cntDigital) {
		case 0:
		setLedMode(15, true); setLedMode(14, true); setLedMode(11, true);
		break;
		case 1: case 2: case 3:
		setLedMode(15, true); setLedMode(13, true); setLedMode(10, true);
		break;
		case 4:
		setLedMode(15, true); setLedMode(12, true); setLedMode(11, true);
		break;
	}
}

/************************************************************************/
/* Darstellung Digital 6                                                */
/************************************************************************/
void digitalSix(void) {
	// LED16	-####
	// LED15	#----
	// LED14	####-
	// LED13	#---#
	// LED12	#---#
	// LED11	-###-
	switch(cntDigital) {
		case 0:
		setLedMode(14, true); setLedMode(13, true); setLedMode(12, true); setLedMode(11, true);
		break;
		case 1: case 2: case 3:
		setLedMode(15, true); setLedMode(13, true); setLedMode(10, true);
		break;
		case 4:
		setLedMode(15, true); setLedMode(12, true); setLedMode(11, true);
		break;
	}
}

/************************************************************************/
/* Darstellung Digital 7                                                */
/************************************************************************/
void digitalSeven(void) {
	// LED16	#####
	// LED15	----#
	// LED14	---#-
	// LED13	#####
	// LED12	-#---
	// LED11	#----
	switch(cntDigital) {
		case 0:
		setLedMode(15, true); setLedMode(12, true); setLedMode(10, true);
		break;
		case 1:
		setLedMode(15, true); setLedMode(12, true); setLedMode(11, true);
		break;
		case 2:
		setLedMode(15, true); setLedMode(12, true);
		break;
		case 3:
		setLedMode(15, true); setLedMode(13, true); setLedMode(12, true);
		break;
		case 4:
		setLedMode(15, true); setLedMode(14, true); setLedMode(12, true);
		break;
	}
}

/************************************************************************/
/* Darstellung Digital 8                                                */
/************************************************************************/
void digitalEight(void) {
	// LED16	-###-
	// LED15	#---#
	// LED14	-###-
	// LED13	#---#
	// LED12	#---#
	// LED11	-###-
	switch(cntDigital) {
		case 0: case 4:
		setLedMode(14, true); setLedMode(12, true); setLedMode(11, true);
		break;
		case 1: case 2: case 3:
		setLedMode(15, true); setLedMode(13, true); setLedMode(10, true);
		break;
	}
}

/************************************************************************/
/* Darstellung Digital 9                                                */
/************************************************************************/
void digitalNine(void) {
	// LED16	-###-
	// LED15	#---#
	// LED14	#---#
	// LED13	-####
	// LED12	----#
	// LED11	-###-
	switch(cntDigital) {
		case 0:
		setLedMode(14, true); setLedMode(13, true);
		break;
		case 1: case 2: case 3:
		setLedMode(15, true); setLedMode(12, true); setLedMode(10, true);
		break;
		case 4:
		setLedMode(14, true); setLedMode(13, true); setLedMode(12, true); setLedMode(11, true);
		break;
	}
}